package org.dromara.biz.service.impl;

import org.dromara.common.core.service.OssService;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.biz.domain.bo.BizTaskWorkBo;
import org.dromara.biz.domain.vo.BizTaskWorkVo;
import org.dromara.biz.domain.BizTaskWork;
import org.dromara.biz.mapper.BizTaskWorkMapper;
import org.dromara.biz.service.IBizTaskWorkService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 任务协作单Service业务层处理
 *
 * @author chenle
 * @date 2025-05-22
 */
@RequiredArgsConstructor
@Service
public class BizTaskWorkServiceImpl implements IBizTaskWorkService {

    private final BizTaskWorkMapper baseMapper;
    private final OssService ossService;

    /**
     * 查询任务协作单
     *
     * @param id 主键
     * @return 任务协作单
     */
    @Override
    public BizTaskWorkVo queryById(Long id){
        BizTaskWorkVo bizTaskWorkVo = baseMapper.selectVoById(id);
        bizTaskWorkVo.setOssList(ossService.selectByIds(bizTaskWorkVo.getOssId()));
        return  bizTaskWorkVo;
    }

    /**
     * 分页查询任务协作单列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 任务协作单分页列表
     */
    @Override
    public TableDataInfo<BizTaskWorkVo> queryPageList(BizTaskWorkBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<BizTaskWork> lqw = buildQueryWrapper(bo);
        Page<BizTaskWorkVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的任务协作单列表
     *
     * @param bo 查询条件
     * @return 任务协作单列表
     */
    @Override
    public List<BizTaskWorkVo> queryList(BizTaskWorkBo bo) {
        LambdaQueryWrapper<BizTaskWork> lqw = buildQueryWrapper(bo);
        lqw.orderByDesc(BizTaskWork::getId);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<BizTaskWork> buildQueryWrapper(BizTaskWorkBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<BizTaskWork> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(BizTaskWork::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getTaskNo()), BizTaskWork::getTaskNo, bo.getTaskNo());
        lqw.eq(StringUtils.isNotBlank(bo.getDeptId()), BizTaskWork::getDeptId, bo.getDeptId());
        lqw.like(StringUtils.isNotBlank(bo.getDeptName()), BizTaskWork::getDeptName, bo.getDeptName());
        lqw.eq(StringUtils.isNotBlank(bo.getCapacityId()), BizTaskWork::getCapacityId, bo.getCapacityId());
        lqw.eq(bo.getSponsorId() != null, BizTaskWork::getSponsorId, bo.getSponsorId());
        lqw.like(StringUtils.isNotBlank(bo.getSponsorName()), BizTaskWork::getSponsorName, bo.getSponsorName());
        lqw.eq(bo.getAssistantId() != null, BizTaskWork::getAssistantId, bo.getAssistantId());
        lqw.like(StringUtils.isNotBlank(bo.getAssistantName()), BizTaskWork::getAssistantName, bo.getAssistantName());
        lqw.eq(StringUtils.isNotBlank(bo.getWorkContent()), BizTaskWork::getWorkContent, bo.getWorkContent());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), BizTaskWork::getStatus, bo.getStatus());
        return lqw;
    }

    /**
     * 新增任务协作单
     *
     * @param bo 任务协作单
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(BizTaskWorkBo bo) {
        BizTaskWork add = MapstructUtils.convert(bo, BizTaskWork.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改任务协作单
     *
     * @param bo 任务协作单
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(BizTaskWorkBo bo) {
        BizTaskWork update = MapstructUtils.convert(bo, BizTaskWork.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(BizTaskWork entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除任务协作单信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
